diff --git a/web/pgadmin/tools/erd/static/js/erd_tool/components/MainToolBar.jsx b/web/pgadmin/tools/erd/static/js/erd_tool/components/MainToolBar.jsx
new file mode 100644
index 000000000..dc69895dc
--- /dev/null
+++ b/web/pgadmin/tools/erd/static/js/erd_tool/components/MainToolBar.jsx
@@ -0,0 +1,249 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+import React, {useCallback, useEffect, useState} from 'react';
+import { makeStyles } from '@material-ui/styles';
+import { Box } from '@material-ui/core';
+import { PgButtonGroup, PgIconButton } from '../../../../../../static/js/components/Buttons';
+import FolderRoundedIcon from '@material-ui/icons/FolderRounded';
+import KeyboardArrowDownIcon from '@material-ui/icons/KeyboardArrowDown';
+import SaveRoundedIcon from '@material-ui/icons/SaveRounded';
+import HelpIcon from '@material-ui/icons/HelpRounded';
+import ZoomInIcon from '@material-ui/icons/ZoomIn';
+import ZoomOutIcon from '@material-ui/icons/ZoomOut';
+import ZoomOutMapIcon from '@material-ui/icons/ZoomOutMap';
+import AddBoxIcon from '@material-ui/icons/AddBox';
+import EditRoundedIcon from '@material-ui/icons/EditRounded';
+import FileCopyRoundedIcon from '@material-ui/icons/FileCopyRounded';
+import DeleteIcon from '@material-ui/icons/Delete';
+import NoteRoundedIcon from '@material-ui/icons/NoteRounded';
+import VisibilityRoundedIcon from '@material-ui/icons/VisibilityRounded';
+import VisibilityOffRoundedIcon from '@material-ui/icons/VisibilityOffRounded';
+import ImageRoundedIcon from '@material-ui/icons/ImageRounded';
+
+import { PgMenu, PgMenuItem, usePgMenuGroup } from '../../../../../../static/js/components/Menu';
+import gettext from 'sources/gettext';
+import url_for from 'sources/url_for';
+import PropTypes from 'prop-types';
+import { ERD_EVENTS } from '../ERDConstants';
+import { MagicIcon, SQLFileIcon } from '../../../../../../static/js/components/ExternalIcon';
+import { useModal } from '../../../../../../static/js/helpers/ModalProvider';
+
+const useStyles = makeStyles((theme)=>({
+  root: {
+    padding: '2px 4px',
+    display: 'flex',
+    alignItems: 'center',
+    gap: '4px',
+    backgroundColor: theme.otherVars.editorToolbarBg,
+    flexWrap: 'wrap',
+    ...theme.mixins.panelBorder.bottom,
+  },
+  connectionButton: {
+    display: 'flex',
+    width: '450px',
+    backgroundColor: theme.palette.default.main,
+    color: theme.palette.default.contrastText,
+    border: '1px solid ' + theme.palette.default.borderColor,
+    justifyContent: 'flex-start',
+  },
+}));
+
+export function MainToolBar({preferences, eventBus}) {
+  const classes = useStyles();
+  const [buttonsDisabled, setButtonsDisabled] = useState({
+    'save': true,
+    'edit-table': true,
+    'clone-table': true,
+    'one-to-many': true,
+    'many-to-many': true,
+    'show-note': true,
+    'drop-table': true,
+  });
+  const [showDetails, setShowDetails] = useState(true);
+
+  const {openMenuName, toggleMenu, onMenuClose} = usePgMenuGroup();
+  const saveAsMenuRef = React.useRef(null);
+  const isDirtyRef = React.useRef(null);
+  const modal = useModal();
+
+  const setDisableButton = useCallback((name, disable=true)=>{
+    setButtonsDisabled((prev)=>({...prev, [name]: disable}));
+  }, []);
+
+  const onHelpClick=()=>{
+    let url = url_for('help.static', {'filename': 'erd_tool.html'});
+    window.open(url, 'pgadmin_help');
+  };
+  const confirmDiscard=(callback, checkSaved=false)=>{
+    if(checkSaved && buttonsDisabled['save']) {
+      /* No need to check  */
+      callback();
+      return;
+    }
+    modal.confirm(
+      gettext('Unsaved changes'),
+      gettext('Are you sure you wish to discard the current changes?'),
+      function() {
+        callback();
+      },
+      function() {
+        return true;
+      }
+    );
+  };
+
+  useEffect(()=>{
+    const events = [
+      [ERD_EVENTS.SINGLE_NODE_SELECTED, (selected)=>{
+        setDisableButton('edit-table', !selected);
+        setDisableButton('clone-table', !selected);
+        setDisableButton('one-to-many', !selected);
+        setDisableButton('many-to-many', !selected);
+        setDisableButton('show-note', !selected);
+      }],
+      [ERD_EVENTS.ANY_ITEM_SELECTED, (selected)=>{
+        setDisableButton('drop-table', !selected);
+      }],
+      [ERD_EVENTS.DIRTY, (isDirty)=>{
+        isDirtyRef.current = isDirty;
+        setDisableButton('save', !isDirty);
+      }],
+    ];
+    events.forEach((e)=>{
+      eventBus.registerListener(e[0], e[1]);
+    });
+    return ()=>{
+      events.forEach((e)=>{
+        eventBus.deregisterListener(e[0], e[1]);
+      });
+    };
+  }, []);
+
+  return (
+    <>
+      <Box className={classes.root}>
+        <PgButtonGroup size="small">
+          <PgIconButton title={gettext('Load Project')} icon={<FolderRoundedIcon />}
+            shortcut={preferences.open_project} onClick={()=>{
+              confirmDiscard(()=>{
+                eventBus.fireEvent(ERD_EVENTS.LOAD_DIAGRAM);
+              }, true);
+            }} />
+          <PgIconButton title={gettext('Save Project')} icon={<SaveRoundedIcon />}
+            shortcut={preferences.save_project} disabled={buttonsDisabled['save']}
+            onClick={()=>{
+              eventBus.fireEvent(ERD_EVENTS.SAVE_DIAGRAM);
+            }} />
+          <PgIconButton title={gettext('File')} icon={<KeyboardArrowDownIcon />} splitButton
+            name="menu-saveas" ref={saveAsMenuRef} onClick={toggleMenu}
+          />
+        </PgButtonGroup>
+        <PgButtonGroup size="small">
+          <PgIconButton title={gettext('Generate SQL')} icon={<SQLFileIcon />}
+            shortcut={preferences.generate_sql}
+            onClick={()=>{
+              eventBus.fireEvent(ERD_EVENTS.SHOW_SQL);
+            }} />
+          <PgIconButton title={gettext('Download image')} icon={<ImageRoundedIcon />}
+            shortcut={preferences.download_image}
+            onClick={()=>{
+              eventBus.fireEvent(ERD_EVENTS.DOWNLOAD_IMAGE);
+            }} />
+        </PgButtonGroup>
+        <PgButtonGroup size="small">
+          <PgIconButton title={gettext('Add Table')} icon={<AddBoxIcon />}
+            shortcut={preferences.add_table}
+            onClick={()=>{
+              eventBus.fireEvent(ERD_EVENTS.ADD_NODE);
+            }} />
+          <PgIconButton title={gettext('Edit Table')} icon={<EditRoundedIcon />}
+            shortcut={preferences.edit_table} disabled={buttonsDisabled['edit-table']}
+            onClick={()=>{
+              eventBus.fireEvent(ERD_EVENTS.EDIT_NODE);
+            }} />
+          <PgIconButton title={gettext('Clone Table')} icon={<FileCopyRoundedIcon />}
+            shortcut={preferences.clone_table} disabled={buttonsDisabled['clone-table']}
+            onClick={()=>{
+              eventBus.fireEvent(ERD_EVENTS.CLONE_NODE);
+            }} />
+          <PgIconButton title={gettext('Drop Table/Relation')} icon={<DeleteIcon />}
+            shortcut={preferences.drop_table} disabled={buttonsDisabled['drop-table']}
+            onClick={()=>{
+              eventBus.fireEvent(ERD_EVENTS.DELETE_NODE);
+            }} />
+        </PgButtonGroup>
+        <PgButtonGroup size="small">
+          <PgIconButton title={gettext('One-to-Many Relation')} icon={<span style={{letterSpacing: '-1px'}}>1M</span>}
+            shortcut={preferences.one_to_many} disabled={buttonsDisabled['one-to-many']}
+            onClick={()=>{
+              eventBus.fireEvent(ERD_EVENTS.ONE_TO_MANY);
+            }} />
+          <PgIconButton title={gettext('Many-to-Many Relation')} icon={<span style={{letterSpacing: '-1px'}}>MM</span>}
+            shortcut={preferences.many_to_many} disabled={buttonsDisabled['many-to-many']}
+            onClick={()=>{
+              eventBus.fireEvent(ERD_EVENTS.MANY_TO_MANY);
+            }} />
+        </PgButtonGroup>
+        <PgButtonGroup size="small">
+          <PgIconButton title={gettext('Add/Edit Note')} icon={<NoteRoundedIcon />}
+            shortcut={preferences.add_edit_note} disabled={buttonsDisabled['show-note']}
+            onClick={()=>{
+              eventBus.fireEvent(ERD_EVENTS.SHOW_NOTE);
+            }} />
+          <PgIconButton title={gettext('Auto Align')} icon={<MagicIcon />}
+            shortcut={preferences.auto_align}
+            onClick={()=>{
+              eventBus.fireEvent(ERD_EVENTS.AUTO_DISTRIBUTE);
+            }} />
+          <PgIconButton title={gettext('Show Details')} icon={showDetails ? <VisibilityRoundedIcon /> : <VisibilityOffRoundedIcon />}
+            shortcut={preferences.show_details}
+            onClick={()=>{
+              eventBus.fireEvent(ERD_EVENTS.TOGGLE_DETAILS);
+              setShowDetails((prev)=>!prev);
+            }} />
+        </PgButtonGroup>
+        <PgButtonGroup size="small">
+          <PgIconButton title={gettext('Zoom In')} icon={<ZoomInIcon />}
+            shortcut={preferences.zoom_in}
+            onClick={()=>{
+              eventBus.fireEvent(ERD_EVENTS.ZOOM_IN);
+            }} />
+          <PgIconButton title={gettext('Zoom to Fit')} icon={<ZoomOutMapIcon />}
+            shortcut={preferences.zoom_to_fit}
+            onClick={()=>{
+              eventBus.fireEvent(ERD_EVENTS.ZOOM_FIT);
+            }} />
+          <PgIconButton title={gettext('Zoom Out')} icon={<ZoomOutIcon />}
+            shortcut={preferences.zoom_out}
+            onClick={()=>{
+              eventBus.fireEvent(ERD_EVENTS.ZOOM_OUT);
+            }}/>
+        </PgButtonGroup>
+        <PgButtonGroup size="small">
+          <PgIconButton title={gettext('Help')} icon={<HelpIcon />} onClick={onHelpClick} />
+        </PgButtonGroup>
+      </Box>
+      <PgMenu
+        anchorRef={saveAsMenuRef}
+        open={openMenuName=='menu-saveas'}
+        onClose={onMenuClose}
+        label={gettext('File Menu')}
+      >
+        <PgMenuItem onClick={()=>{
+          eventBus.fireEvent(ERD_EVENTS.SAVE_DIAGRAM, true);
+        }}>{gettext('Save as')}</PgMenuItem>
+      </PgMenu>
+    </>
+  );
+}
+
+MainToolBar.propTypes = {
+  preferences: PropTypes.object,
+  eventBus: PropTypes.object,
+};
diff --git a/web/pgadmin/tools/erd/static/js/erd_tool/dialogs/ManyToManyDialog.js b/web/pgadmin/tools/erd/static/js/erd_tool/dialogs/ManyToManyDialog.js
index 4a8db3669..ca431ce91 100644
--- a/web/pgadmin/tools/erd/static/js/erd_tool/dialogs/ManyToManyDialog.js
+++ b/web/pgadmin/tools/erd/static/js/erd_tool/dialogs/ManyToManyDialog.js
@@ -8,10 +8,7 @@
 //////////////////////////////////////////////////////////////
 
 import gettext from 'sources/gettext';
-import Alertify from 'pgadmin.alertifyjs';
 import BaseUISchema from 'sources/SchemaView/base_schema.ui';
-
-import DialogWrapper from './DialogWrapper';
 import _ from 'lodash';
 
 class ManyToManySchema extends BaseUISchema {
@@ -50,59 +47,27 @@ class ManyToManySchema extends BaseUISchema {
   }
 }
 
-export default class ManyToManyDialog {
-  constructor(pgBrowser) {
-    this.pgBrowser = pgBrowser;
-  }
-
-  dialogName() {
-    return 'manytomany_dialog';
-  }
+export function getManyToManyDialogSchema(attributes, tableNodesDict) {
+  let tablesData = [];
+  _.forEach(tableNodesDict, (node, uid)=>{
+    let [schema, name] = node.getSchemaTableName();
+    tablesData.push({value: uid, label: `(${schema}) ${name}`, image: 'icon-table'});
+  });
 
-  getUISchema(attributes, tableNodesDict) {
-    let tablesData = [];
-    _.forEach(tableNodesDict, (node, uid)=>{
-      let [schema, name] = node.getSchemaTableName();
-      tablesData.push({value: uid, label: `(${schema}) ${name}`, image: 'icon-table'});
-    });
-
-    return new ManyToManySchema({
-      left_table_uid: tablesData,
-      left_table_column_attnum: tableNodesDict[attributes.left_table_uid].getColumns().map((col)=>{
+  return new ManyToManySchema({
+    left_table_uid: tablesData,
+    left_table_column_attnum: tableNodesDict[attributes.left_table_uid].getColumns().map((col)=>{
+      return {
+        value: col.attnum, label: col.name, 'image': 'icon-column',
+      };
+    }),
+    right_table_uid: tablesData,
+    getRefColumns: (uid)=>{
+      return tableNodesDict[uid].getColumns().map((col)=>{
         return {
           value: col.attnum, label: col.name, 'image': 'icon-column',
         };
-      }),
-      right_table_uid: tablesData,
-      getRefColumns: (uid)=>{
-        return tableNodesDict[uid].getColumns().map((col)=>{
-          return {
-            value: col.attnum, label: col.name, 'image': 'icon-column',
-          };
-        });
-      },
-    }, attributes);
-  }
-
-  createOrGetDialog(title) {
-    const dialogName = this.dialogName();
-
-    if (!Alertify[dialogName]) {
-      Alertify.dialog(dialogName, () => {
-        return new DialogWrapper(
-          `<div class="${dialogName}"></div>`,
-          title,
-          null,
-          Alertify,
-        );
       });
-    }
-    return Alertify[dialogName];
-  }
-
-  show(title, attributes, tablesData, serverInfo, callback) {
-    let dialogTitle = title || gettext('Unknown');
-    const dialog = this.createOrGetDialog('manytomany_dialog', serverInfo);
-    dialog(dialogTitle, this.getUISchema(attributes, tablesData), callback).resizeTo(this.pgBrowser.stdW.sm, this.pgBrowser.stdH.md);
-  }
+    },
+  }, attributes);
 }
diff --git a/web/pgadmin/tools/erd/static/js/erd_tool/dialogs/OneToManyDialog.js b/web/pgadmin/tools/erd/static/js/erd_tool/dialogs/OneToManyDialog.js
index c9273c63f..4d6e48250 100644
--- a/web/pgadmin/tools/erd/static/js/erd_tool/dialogs/OneToManyDialog.js
+++ b/web/pgadmin/tools/erd/static/js/erd_tool/dialogs/OneToManyDialog.js
@@ -8,10 +8,7 @@
 //////////////////////////////////////////////////////////////
 
 import gettext from 'sources/gettext';
-import Alertify from 'pgadmin.alertifyjs';
 import BaseUISchema from 'sources/SchemaView/base_schema.ui';
-
-import DialogWrapper from './DialogWrapper';
 import _ from 'lodash';
 
 class OneToManySchema extends BaseUISchema {
@@ -50,60 +47,27 @@ class OneToManySchema extends BaseUISchema {
   }
 }
 
-export default class OneToManyDialog {
-  constructor(pgBrowser) {
-    this.pgBrowser = pgBrowser;
-  }
-
-  dialogName() {
-    return 'onetomany_dialog';
-  }
+export function getOneToManyDialogSchema(attributes, tableNodesDict) {
+  let tablesData = [];
+  _.forEach(tableNodesDict, (node, uid)=>{
+    let [schema, name] = node.getSchemaTableName();
+    tablesData.push({value: uid, label: `(${schema}) ${name}`, image: 'icon-table'});
+  });
 
-  getUISchema(attributes, tableNodesDict) {
-    let tablesData = [];
-    _.forEach(tableNodesDict, (node, uid)=>{
-      let [schema, name] = node.getSchemaTableName();
-      tablesData.push({value: uid, label: `(${schema}) ${name}`, image: 'icon-table'});
-    });
-
-    return new OneToManySchema({
-      local_table_uid: tablesData,
-      local_column_attnum: tableNodesDict[attributes.local_table_uid].getColumns().map((col)=>{
+  return new OneToManySchema({
+    local_table_uid: tablesData,
+    local_column_attnum: tableNodesDict[attributes.local_table_uid].getColumns().map((col)=>{
+      return {
+        value: col.attnum, label: col.name, 'image': 'icon-column',
+      };
+    }),
+    referenced_table_uid: tablesData,
+    getRefColumns: (uid)=>{
+      return tableNodesDict[uid].getColumns().map((col)=>{
         return {
           value: col.attnum, label: col.name, 'image': 'icon-column',
         };
-      }),
-      referenced_table_uid: tablesData,
-      getRefColumns: (uid)=>{
-        return tableNodesDict[uid].getColumns().map((col)=>{
-          return {
-            value: col.attnum, label: col.name, 'image': 'icon-column',
-          };
-        });
-      },
-    }, attributes);
-  }
-
-  createOrGetDialog(title, sVersion) {
-    const dialogName = this.dialogName();
-
-    if (!Alertify[dialogName]) {
-      Alertify.dialog(dialogName, () => {
-        return new DialogWrapper(
-          `<div class="${dialogName}"></div>`,
-          title,
-          null,
-          Alertify,
-          sVersion
-        );
       });
-    }
-    return Alertify[dialogName];
-  }
-
-  show(title, attributes, tablesData, serverInfo, callback) {
-    let dialogTitle = title || gettext('Unknown');
-    const dialog = this.createOrGetDialog('onetomany_dialog', serverInfo);
-    dialog(dialogTitle, this.getUISchema(attributes, tablesData), callback).resizeTo(this.pgBrowser.stdW.sm, this.pgBrowser.stdH.md);
-  }
+    },
+  }, attributes);
 }
diff --git a/web/pgadmin/tools/erd/static/js/erd_tool/dialogs/TableDialog.js b/web/pgadmin/tools/erd/static/js/erd_tool/dialogs/TableDialog.js
index ddb02633a..8892a5be3 100644
--- a/web/pgadmin/tools/erd/static/js/erd_tool/dialogs/TableDialog.js
+++ b/web/pgadmin/tools/erd/static/js/erd_tool/dialogs/TableDialog.js
@@ -7,12 +7,9 @@
 //
 //////////////////////////////////////////////////////////////
 
-import gettext from 'sources/gettext';
-import Alertify from 'pgadmin.alertifyjs';
 import _ from 'lodash';
 import BaseUISchema from 'sources/SchemaView/base_schema.ui';
 
-import DialogWrapper from './DialogWrapper';
 import TableSchema, { ConstraintsSchema } from '../../../../../../browser/server_groups/servers/databases/schemas/tables/static/js/table.ui';
 import ColumnSchema from '../../../../../../browser/server_groups/servers/databases/schemas/tables/columns/static/js/column.ui';
 import ForeignKeySchema from '../../../../../../browser/server_groups/servers/databases/schemas/tables/constraints/foreign_key/static/js/foreign_key.ui';
@@ -26,106 +23,73 @@ class EmptySchema extends BaseUISchema {
   }
 }
 
-export default class TableDialog {
-  constructor(pgBrowser) {
-    this.pgBrowser = pgBrowser;
-  }
-
-  dialogName() {
-    return 'table_dialog';
-  }
-
-  getUISchema(attributes, isNew, tableNodesDict, colTypes, schemas) {
-    let treeNodeInfo = undefined;
-
-    let columnSchema = new ColumnSchema(
-      ()=>{/*This is intentional (SonarQube)*/},
-      treeNodeInfo,
-      ()=>colTypes,
-      ()=>[],
-      ()=>[],
-      true,
-    );
+export function getTableDialogSchema(attributes, isNew, tableNodesDict, colTypes, schemas) {
+  let treeNodeInfo = undefined;
 
-    return new TableSchema(
-      {
-        relowner: [],
-        schema: schemas.map((schema)=>{
-          return {
-            'value': schema['name'],
-            'image': 'icon-schema',
-            'label': schema['name'],
-          };
-        }),
-        spcname: [],
-        coll_inherits: [],
-        typname: [],
-        like_relation: [],
-      },
-      treeNodeInfo,
-      {
-        columns: ()=>columnSchema,
-        vacuum_settings: ()=>new EmptySchema(),
-        constraints: ()=>new ConstraintsSchema(
-          treeNodeInfo,
-          ()=>new ForeignKeySchema({
-            local_column: [],
-            references: ()=>{
-              let retOpts = [];
-              _.forEach(tableNodesDict, (node, uid)=>{
-                let [schema, name] = node.getSchemaTableName();
-                retOpts.push({value: uid, label: `(${schema}) ${name}`});
-              });
-              return retOpts;
-            }
-          },
-          treeNodeInfo,
-          (params)=>{
-            if(params.tid) {
-              return tableNodesDict[params.tid].getColumns().map((col)=>{
-                return {
-                  value: col.name, label: col.name, 'image': 'icon-column',
-                };
-              });
-            }
-          }, {autoindex: false}, true),
-          ()=>new EmptySchema(),
-          {spcname: []},
-          true
-        ),
-      },
-      ()=>new EmptySchema(),
-      ()=>[],
-      ()=>[],
-      ()=>[],
-      ()=>[],
-      isNew ? {
-        schema: schemas[0]?.name,
-      } : attributes,
-      true
-    );
-  }
-
-  createOrGetDialog(type, sVersion) {
-    const dialogName = this.dialogName();
+  let columnSchema = new ColumnSchema(
+    ()=>{/*This is intentional (SonarQube)*/},
+    treeNodeInfo,
+    ()=>colTypes,
+    ()=>[],
+    ()=>[],
+    true,
+  );
 
-    if (!Alertify[dialogName]) {
-      Alertify.dialog(dialogName, () => {
-        return new DialogWrapper(
-          `<div class="${dialogName}"></div>`,
-          null,
-          type,
-          Alertify,
-          sVersion
-        );
-      });
-    }
-    return Alertify[dialogName];
-  }
-
-  show(title, attributes, isNew, tableNodesDict, colTypes, schemas, serverInfo, callback) {
-    let dialogTitle = title || gettext('Unknown');
-    const dialog = this.createOrGetDialog('table_dialog', serverInfo);
-    dialog(dialogTitle, this.getUISchema(attributes, isNew, tableNodesDict, colTypes, schemas, serverInfo), callback).resizeTo(this.pgBrowser.stdW.lg, this.pgBrowser.stdH.md);
-  }
+  return new TableSchema(
+    {
+      relowner: [],
+      schema: schemas.map((schema)=>{
+        return {
+          'value': schema['name'],
+          'image': 'icon-schema',
+          'label': schema['name'],
+        };
+      }),
+      spcname: [],
+      coll_inherits: [],
+      typname: [],
+      like_relation: [],
+    },
+    treeNodeInfo,
+    {
+      columns: ()=>columnSchema,
+      vacuum_settings: ()=>new EmptySchema(),
+      constraints: ()=>new ConstraintsSchema(
+        treeNodeInfo,
+        ()=>new ForeignKeySchema({
+          local_column: [],
+          references: ()=>{
+            let retOpts = [];
+            _.forEach(tableNodesDict, (node, uid)=>{
+              let [schema, name] = node.getSchemaTableName();
+              retOpts.push({value: uid, label: `(${schema}) ${name}`});
+            });
+            return retOpts;
+          }
+        },
+        treeNodeInfo,
+        (params)=>{
+          if(params.tid) {
+            return tableNodesDict[params.tid].getColumns().map((col)=>{
+              return {
+                value: col.name, label: col.name, 'image': 'icon-column',
+              };
+            });
+          }
+        }, {autoindex: false}, true),
+        ()=>new EmptySchema(),
+        {spcname: []},
+        true
+      ),
+    },
+    ()=>new EmptySchema(),
+    ()=>[],
+    ()=>[],
+    ()=>[],
+    ()=>[],
+    isNew ? {
+      schema: schemas[0]?.name,
+    } : attributes,
+    true
+  );
 }
diff --git a/web/pgadmin/tools/erd/static/js/erd_tool/dialogs/index.jsx b/web/pgadmin/tools/erd/static/js/erd_tool/dialogs/index.jsx
new file mode 100644
index 000000000..f45cc1787
--- /dev/null
+++ b/web/pgadmin/tools/erd/static/js/erd_tool/dialogs/index.jsx
@@ -0,0 +1,95 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import {getTableDialogSchema} from './TableDialog';
+import {getOneToManyDialogSchema} from './OneToManyDialog';
+import {getManyToManyDialogSchema} from './ManyToManyDialog';
+
+import pgAdmin from 'sources/pgadmin';
+import SchemaView from '../../../../../../static/js/SchemaView';
+import React from 'react';
+export default class ERDDialogs {
+  constructor(modalProvider) {
+    this.modal = modalProvider;
+  }
+
+  onSaveClick(_isNew, data, closeModal, okCallback) {
+    return new Promise((resolve, reject)=>{
+      let errorMsg = okCallback(data);
+      if(errorMsg) {
+        reject(errorMsg);
+      } else {
+        closeModal();
+        resolve();
+      }
+    });
+  }
+
+  showTableDialog(params) {
+    let schema = getTableDialogSchema(
+      params.attributes, params.isNew, params.tableNodes,
+      params.colTypes, params.schemas);
+    this.modal.showModal(params.title, (closeModal)=>{
+      return (
+        <SchemaView
+          formType={'dialog'}
+          getInitData={()=>Promise.resolve({})}
+          schema={schema}
+          viewHelperProps={{
+            mode: 'create',
+            keepCid: true,
+            serverInfo: params.serverInfo,
+          }}
+          onSave={(...args)=>this.onSaveClick(...args, closeModal, params.callback)}
+          onClose={closeModal}
+          onDataChange={()=>{/*This is intentional (SonarQube)*/}}
+          hasSQL={false}
+          disableSqlHelp={true}
+          disableDialogHelp={true}
+        />
+      );
+    }, {
+      isResizeable: true,
+      dialogWidth: pgAdmin.Browser?.stdW?.lg, dialogHeight: pgAdmin.Browser?.stdH?.md,
+    });
+  }
+
+  showRelationDialog(dialogName, params) {
+    let schema;
+    if(dialogName === 'onetomany_dialog') {
+      schema = getOneToManyDialogSchema(params.attributes, params.tableNodes);
+    } else if(dialogName === 'manytomany_dialog') {
+      schema = getManyToManyDialogSchema(params.attributes, params.tableNodes);
+    }
+
+    this.modal.showModal(params.title, (closeModal)=>{
+      return (
+        <SchemaView
+          formType={'dialog'}
+          getInitData={()=>Promise.resolve({})}
+          schema={schema}
+          viewHelperProps={{
+            mode: 'create',
+            keepCid: true,
+            serverInfo: params.serverInfo,
+          }}
+          onSave={(...args)=>this.onSaveClick(...args, closeModal, params.callback)}
+          onClose={closeModal}
+          onDataChange={()=>{/*This is intentional (SonarQube)*/}}
+          hasSQL={false}
+          disableSqlHelp={true}
+          disableDialogHelp={true}
+        />
+      );
+    }, {
+      isResizeable: true,
+      dialogWidth: pgAdmin.Browser?.stdW?.lg, dialogHeight: pgAdmin.Browser?.stdH?.md,
+    });
+  }
+}
diff --git a/web/pgadmin/tools/erd/static/js/erd_tool/links/OneToManyLink.jsx b/web/pgadmin/tools/erd/static/js/erd_tool/links/OneToManyLink.jsx
index be6cf8d7e..fc6d1d1a6 100644
--- a/web/pgadmin/tools/erd/static/js/erd_tool/links/OneToManyLink.jsx
+++ b/web/pgadmin/tools/erd/static/js/erd_tool/links/OneToManyLink.jsx
@@ -7,7 +7,7 @@
 //
 //////////////////////////////////////////////////////////////
 
-import React from 'react';
+import React, { forwardRef } from 'react';
 import {
   RightAngleLinkModel,
   RightAngleLinkWidget,
@@ -19,6 +19,8 @@ import {
 import {Point} from '@projectstorm/geometry';
 import _ from 'lodash';
 import PropTypes from 'prop-types';
+import { makeStyles } from '@material-ui/core';
+import clsx from 'clsx';
 
 export const OneToManyModel = {
   local_table_uid: undefined,
@@ -74,20 +76,42 @@ export class OneToManyLinkModel extends RightAngleLinkModel {
   }
 }
 
+const useStyles = makeStyles((theme)=>({
+  svgLink: {
+    stroke: theme.palette.text.primary,
+  },
+  '@keyframes svgLinkSelected': {
+    'from': { strokeDashoffset: 24},
+    'to': { strokeDashoffset: 0 }
+  },
+  svgLinkSelected: {
+    strokeDasharray: '10, 2',
+    animation: '$svgLinkSelected 1s linear infinite'
+  },
+  svgLinkCircle: {
+    fill: theme.palette.text.primary,
+  },
+  svgLinkPath: {
+    pointerEvents: 'all',
+    cursor: 'move',
+  }
+}));
+
 const CustomLinkEndWidget = props => {
   const { point, rotation, tx, ty, type } = props;
+  const classes = useStyles();
 
   const svgForType = (itype) => {
     if(itype == 'many') {
       return (
         <>
-          <circle className="svg-link-ele svg-otom-circle" cx="0" cy="16" r={props.width*1.75} strokeWidth={props.width} />
-          <polyline className="svg-link-ele" points="-8,0 0,15 0,0 0,30 0,15 8,0" fill="none" strokeWidth={props.width} />
+          <circle className={clsx(classes.svgLink, classes.svgLinkCircle)} cx="0" cy="16" r={props.width*1.75} strokeWidth={props.width} />
+          <polyline className={classes.svgLink} points="-8,0 0,15 0,0 0,30 0,15 8,0" fill="none" strokeWidth={props.width} />
         </>
       );
     } else if (itype == 'one') {
       return (
-        <polyline className="svg-link-ele" points="-8,15 0,15 0,0 0,30 0,15 8,15" fill="none" strokeWidth={props.width} />
+        <polyline className={classes.svgLink} points="-8,15 0,15 0,0 0,30 0,15 8,15" fill="none" strokeWidth={props.width} />
       );
     }
   };
@@ -270,6 +294,29 @@ export class OneToManyLinkWidget extends RightAngleLinkWidget {
   }
 }
 
+const LinkSegment = forwardRef(({model, selected, path, ...props}, ref)=>{
+  const classes = useStyles();
+  return (
+    <path
+      ref={ref}
+      className={clsx(classes.svgLink, classes.svgLinkPath, (selected ? classes.svgLinkSelected : ''))}
+      stroke={model.getOptions().color}
+      strokeWidth={model.getOptions().width}
+      selected={selected}
+      d={path}
+      {...props}
+    >
+    </path>
+  );
+});
+LinkSegment.displayName = 'LinkSegment';
+LinkSegment.propTypes = {
+  model: PropTypes.object,
+  selected: PropTypes.bool,
+  path: PropTypes.any,
+};
+
+
 export class OneToManyLinkFactory extends DefaultLinkFactory {
   constructor() {
     super('onetomany');
@@ -280,19 +327,10 @@ export class OneToManyLinkFactory extends DefaultLinkFactory {
   }
 
   generateReactWidget(event) {
-    return <OneToManyLinkWidget color='#fff' width={1} smooth={true} link={event.model} diagramEngine={this.engine} factory={this} />;
+    return <OneToManyLinkWidget width={1} smooth={true} link={event.model} diagramEngine={this.engine} factory={this} />;
   }
 
   generateLinkSegment(model, selected, path) {
-    return (
-      <path
-        className={'svg-link-ele path ' + (selected ? 'selected' : '')}
-        stroke={model.getOptions().color}
-        selected={selected}
-        strokeWidth={model.getOptions().width}
-        d={path}
-      >
-      </path>
-    );
+    return <LinkSegment model={model} selected={selected} path={path} />;
   }
 }
